# -*- coding: utf-8 -*-
#
# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license.
#
# v3.2~mickyz

DEVICE = '/dev/cdrom'

DISC_FRAME1    =  2
DISC_FRAMEn    = -2
DISC_LENGTH    = -1
DISC_CHECKSUM  =  0
DISC_NB_TRACKS =  1

(
    ROW_PIXBUF,
    ROW_NAME,
    ROW_TRACK
) = range(3)

def loadDisc():
    """ Read disc information """
    import DiscID

    try:
        discInfo = DiscID.disc_id(DiscID.open(DEVICE))
        return updateTracks(discInfo)

    except Exception, err:
        from tools import log

        log.c.error(err)
        return None

def updateTracks(discInfo):
    """ Update the tracklist """
    from media.cdtrack import CDTrack

    # compute length of each track
    trackLen = [int(round((discInfo[DISC_FRAME1 +i +1]
        -discInfo[DISC_FRAME1 +i]) /75.0))
        for i in xrange(discInfo[DISC_NB_TRACKS] -1)]
    trackLen.append(discInfo[DISC_LENGTH]
        -int(round(discInfo[DISC_FRAMEn] /75.0)))
    tracks = []
    # set track information
    for i in xrange(discInfo[DISC_NB_TRACKS]):
        title, artist, album = 'Track %02u.wav' % (i+1), '~', 'AudioCD'

        track = CDTrack(str(i+1))
        track.setTitle(title)
        track.setAlbum(album)
        track.setArtist(artist)
        track.setLength(trackLen[i])
        track.setNumber(i+1)

        tracks.append(track)

    return tracks
