# -*- coding: utf-8 -*-
#
# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license.
#
# v3.0~mickyz

TAGS = ('title', 'artist', 'album', 'image', 'bitrate', 'channel-mode',)
KEYS = {}

def getTrack(track, tags, length, rate, uri):
    """ Return a Track object by the gst tags """
    for k in TAGS: KEYS[k] = None
    for k in dict(tags).iteritems():
        try:
            KEYS[k[0]] = str(k[1]).decode('utf-8')
        except:
            KEYS[k[0]] = k
    # stream info
    track.setLength(int(length/1000000000))
    if KEYS['bitrate']:
        track.setBitrate(int(KEYS['bitrate']))#/1000)
        if KEYS['channel-mode'] != 'stereo':
            track.setVariableBitrate()
        if rate:
            track.setSampleRate(rate)
    # tag keys
    if KEYS['title']:
        track.setTitle(KEYS['title'])
    if KEYS['artist']:
        track.setArtist(KEYS['artist'])
    if KEYS['album']:
        track.setAlbum(KEYS['album'])
    if KEYS['image']:
        import os.path
        from tools import consts, log

        data = KEYS['image'][1]
        file = os.path.join(os.path.dirname(uri[7:]), '.image.jpg')
        try:
            consts.pixSave(data, file)
        except Exception, err:
            log.c.error(err)

    return track
