# -*- coding: utf-8 -*-
#
# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license.
#
# v3.0~mickyz

import gtk, os

from mutagen.flac import FLAC
from mutagen.easyid3 import EasyID3
from mutagen.oggvorbis import OggVorbis

FORMATS = {
    '.flac':'FLAC',
    '.mp3': 'EasyID3',
    '.oga': 'OggVorbis',
    '.ogg': 'OggVorbis'
	}
KEYS = ['artist', 'album', 'title',]

def Tagger(window, trkPth):
    """ Initialization """
    try:
        trkFln = os.path.basename(trkPth)
        trkExt = os.path.splitext(trkFln)[1].lower()
        trkFmt = trkExt in FORMATS.keys()
        print trkExt, FORMATS.keys()
    except:
        return

    keys = {}    
    v = gtk.VBox()
    for key in KEYS:
        keys[key] = gtk.Entry()
        w = keys[key]
        w.set_text(key.title())
        w.set_sensitive(trkFmt)
        v.add(w)
    h = gtk.HBox()
    e = gtk.Entry()
    e.set_text(trkFln)
    e.set_sensitive(False)
    h.add(e)
    c = gtk.CheckButton()
    c.connect('toggled', lambda w: e.set_sensitive(w.get_active()))
    c.set_active(False)
    h.pack_start(c, False, False, 0)
    h.set_spacing(3)
    v.set_spacing(6)
    v.add(h)
    h = gtk.HBox()
    h.pack_start(v, True, True, 6) 
    d = gtk.Dialog(trkFln, window,
        gtk.DIALOG_MODAL, (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
    d.set_default_size(300,1)
    d.set_border_width(3)
    a = d.get_content_area()
    a.get_children()[1].get_children()[0].grab_focus()
    a.pack_start(h, True, True, 6)
    d.show_all()

    if trkFmt:
        __readTag(trkPth, trkExt, keys)
        _keys = {}
        for key in keys.keys():
            _keys[key] = keys[key].get_text()

    response = d.run()

    if c.get_active():
        try:
            newFln = os.path.splitext(e.get_text())[0]
            newPth = os.path.join(os.path.dirname(trkPth), newFln +trkExt)
            if not os.path.exists(newPth):
                os.rename(trkPth, newPth)
        except:
            newPth = None
    else:
        newPth = None

    if trkFmt:
        if newPth:
            trkPth = newPth
        for key in keys.copy():
            value = keys[key].get_text()
            if value in _keys.values():
                keys.pop(key)
        if len(keys) != 0:
            __writeTag(trkPth, trkExt, keys)
            newPth = trkPth

    d.destroy()

    return newPth

def __deleteTag(path, ext):
    """ Delete the tag information """
    EXT = eval(FORMATS[ext])

    try:
        audio = EXT(path)
        audio.delete()
    except:
        pass

def __readTag(path, ext, keys):
    """ Read the tag information """
    EXT = eval(FORMATS[ext])

    try:
        audio = EXT(path)
        akeys = audio.pprint()
        if not akeys: raise
    except:
        return

    for ak in akeys.split('\n'):
        try:
            key, value = ak.split('=')
            keys[key].set_text(value.replace('\x00',''))
        except:
            continue

def __writeTag(path, ext, keys):
    """ Write the tag information """
    EXT = eval(FORMATS[ext])

    try: audio = EXT(path)
    except: audio = EXT()

    for key in keys:
        try:
            value = keys[key].get_text()
            if value != '': audio[key] = value
            else: audio.pop(key)
        except:
            continue

    try: audio.save()
    except: audio.save(path)
