# -*- coding: utf-8 -*-
#
# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license.
#
# v3.0~mickyz#FIXME

import media, modules
from tools import consts, prefs

MOD_INFO = ('CmdLine', 'CmdLine', '', True, False, None)

class CmdLine(modules.ThreadedModule):

    def __init__(self):
        """ Constructor """
        handlers = {
            consts.MSG_EVT_APP_STARTED:     self.onAppStarted,
            consts.MSG_EVT_APP_QUIT:        self.onAppQuit,
            consts.MSG_EVT_NEW_TRACK:       self.onNewTrack,
            consts.MSG_EVT_NEW_TRACKLIST:   self.onNewTracklist,
            consts.MSG_EVT_TRACK_POSITION:  self.onNewTrackPosition,
            consts.MSG_EVT_STOPPED:         self.onStopped,
                   }

        modules.ThreadedModule.__init__(self, handlers)

    def onAppStarted(self):
        """ Fill the playlist by files given on command or restoring it """
        self.lastTracks   = []
        self.lastTrack  = None
        self.lastPos    = 0

        options, args = prefs.getCmdLine()
        if args:
            modules.postMsg(consts.MSG_CMD_TRACKLIST_SET, {
                'tracks': media.getTracks(args), 'playNow': True})
        else:
            try:
                tracks = media.getPlaylist()
            except:
                tracks = None

            if tracks:
                modules.postMsg(consts.MSG_CMD_TRACKLIST_SET, {
                    'tracks': tracks, 'playNow': False})

            if tracks and eval(str(options))['new'] == False:
                oldTrk = prefs.get(__name__, 'last-trk', 0)
                oldPos = prefs.get(__name__, 'last-pos', 0)
                print 53, oldTrk, oldPos
                if oldPos > 1:
                    modules.postMsg(consts.MSG_CMD_TRACKLIST_PLAY,
                        {'trackIdx': oldTrk, 'playNow': True})
                    modules.postMsg(consts.MSG_CMD_SEEK, {'seconds': oldPos})
                    print "Loaded: Resume"


    def onAppQuit(self):#FIXME
        """ The application is about to terminate """
        media.setPlaylist(self.lastTracks)
        media.setTrackToIndex(None, None)
        #print 66, self.lastTrack.getPlaylistPos() -1
        if self.lastTrack:
            self.lastTrack = self.lastTrack.getPlaylistPos() -1

        prefs.set(__name__, 'last-trk', self.lastTrack)
        prefs.set(__name__, 'last-pos', self.lastPos)

    def onNewTrack(self, track):
        """ A new track is being played """
        self.lastTrack = track

        media.setTrackToIndex(track, track.getFilePath())        

    def onNewTracklist(self, tracks, playtime):
        """ A new tracklist has been set """
        self.lastTracks = tracks

    def onNewTrackPosition(self, seconds):
        """ The track position has changed """
        self.lastPos = seconds

    def onStopped(self):
        """ The playback has been stopped """
        self.lastPos = 0
