# -*- coding: utf-8 -*-
#
# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license.
#
# v3.0~mickyz #FIXME

import gtk, modules, os, subprocess
from media import track
from tools import consts


MOD_INFO = ('Now Playing', 'Now Playing', 'Conky cover widget',
    False, False, 2)

HOME_PATH = os.path.expanduser('~')
PNG_PATH = os.path.join(HOME_PATH, '.now-playing.png')
TXT_PATH = os.path.join(HOME_PATH, '.now-playing.txt')
CFG_PATH = os.path.join(HOME_PATH, '.db2conkyrc')
CFG_FILE = """# conky -c %s #
double_buffer yes
no_buffers yes
imlib_cache_size 0
update_interval 2
alignment bl
minimum_size 130
maximum_width 130
gap_x 20
gap_y 40
default_color ffffff
default_shade_color 000000
draw_shades yes
font Ubuntu:size=9
format_human_readable
override_utf8_locale yes
uppercase no
use_xft yes
xftfont Ubuntu:size=9
xftalpha 0.5
own_window_hints below,sticky,skip_taskbar,skip_pager,undecorated
own_window_transparent yes
own_window_type override
own_window yes

TEXT
${image ~/.now-playing.png -p 12,10}







$alignc${tail ~/.now-playing.txt 2}
""" % CFG_PATH


class NowPlaying(modules.ThreadedModule):

    def __init__(self):
        """ Initialize the module """
        handlers = {
            consts.MSG_EVT_APP_STARTED: self.onAppStarted,
            consts.MSG_EVT_APP_QUIT:    self.onAppQuit,
            consts.MSG_EVT_MOD_LOADED:  self.onAppStarted,
            consts.MSG_EVT_MOD_UNLOADED: self.onAppQuit,
            consts.MSG_EVT_NEW_COVER:   self.onNewCover,
            consts.MSG_EVT_NEW_TRACK:   self.onNewTrack,
            consts.MSG_EVT_STOPPED:     self.onStopped,
                   }

        modules.ThreadedModule.__init__(self, handlers)

        self.onNewCover(consts.pixBuf('cover-frame.png'), None)
        with open(TXT_PATH, 'w') as f:
            f.write('\n\n')

    def onAppStarted(self):
        """ The application has been started """
        self.conkyPopen = subprocess.Popen(['conky', '-q', '-c', CFG_PATH])

    def onAppQuit(self):
        """ The application is about to terminate """
        if self.conkyPopen: self.conkyPopen.kill()

    def onNewCover(self, pixThumbnail, pathFullSize):
        """ The cover picture has changed """        
        pixThumbnail.save(PNG_PATH, 'png')

    def onNewTrack(self, track):
        """ A new track is being played """
        if track:
            with open(TXT_PATH, 'w') as f:
                f.write(track.format('{title}\n{artist}'))

    def onStopped(self):
        """ Stopped the conky widget """
        with open(TXT_PATH, 'w') as f:
            f.write('\n\n')
            #f.write('%s\n%s' % (consts.appName, consts.appComment))
            #txt = '' # fill text for not resize conky heigth 
            #for x in range(len(TEXT_ITEMS.split('\n'))): txt += '\n'
            #output.write(txt)
